# $Id: http-body.bro,v 1.3 2002/10/13 21:07:59 vern Exp $

# Counts length of data.
#
# If log_HTTP_data = T, it also outputs an abstract of data.

@load http

redef process_HTTP_data = T;
redef log_HTTP_data = T;

event http_entity_data(c: connection, is_orig: bool, length: count, data: string)
	{
	local s = lookup_http_request_stream(c);
	local msg = get_http_message(s, is_orig);
	local len = byte_len(data);

	msg$data_length = msg$data_length + length;

	if ( log_HTTP_data )
		{
		local abstract: string;
		if ( len > 40 )
			abstract = cat(sub_bytes(data, 1, 40), "...");
		else
			abstract = data;

		print http_log, fmt("%.6f %s %s %d bytes: \"%s\"",
					network_time(), s$id,
					is_orig ? "=>" : "<=", length,
					abstract);
		}
	}
